<?php /*
Plugin Name: RV Maps&Earth
Version: 2.1.a
Description: Extend your gallery with Google Maps and Google Earth ...
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=122
Author: rvelices
Author URI: http://www.modusoptimus.com/
*/
define( 'RVM_PLUGIN_VERSION', '2.1.a');
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

add_event_handler('loc_end_index', 'rvm_end_index' );
add_event_handler('loc_begin_index_category_thumbnails', 'rvm_index_cat_thumbs_displayed');
add_event_handler('loc_begin_index_thumbnails', 'rvm_begin_index_thumbnails');

add_event_handler('picture_pictures_data', 'rvm_picture_pictures_data' );
add_event_handler('get_admin_plugin_menu_links', 'rvm_plugin_admin_menu' );

global $rvm_dir;
$rvm_dir = basename( dirname(__FILE__) );


function rvm_index_cat_thumbs_displayed()
{
	global $page;
	$page['rvm_cat_thumbs_displayed'] = true;
}

function rvm_begin_index_thumbnails( $pictures )
{
	global $page;
	foreach ($pictures as $picture)
	{
		if ( isset($picture['lat']) )
		{
			$page['rvm_items_have_latlon'] = true;
			break;
		}
	}
}

function rvm_end_index()
{
	global $page, $filter, $template, $rvm_dir;

	//if ( !is_admin() ) return; // TEMP
	if ( isset($page['chronology_field']) || $filter['enabled'] )
		return;

	if ( 'categories' == @$page['section'])
	{ // flat or no flat ; has subcats or not;  ?
		if ( ! @$page['rvm_cat_thumbs_displayed'] and empty($page['items']) )
			return;
	}
	else
	{
		if (
			!in_array( @$page['section'], array('tags','search','recent_pics','list') )
			)
			return;
		if ( empty($page['items']) )
			return;
	}

	include_once( dirname(__FILE__) .'/include/functions.php');

	if ( !empty($page['items']) )
	{
		if (!@$page['rvm_items_have_latlon'] and ! rvm_items_have_latlon( $page['items'] ) )
			return;
	}
	rvm_load_language();

	$map_url = rvm_duplicate_map_index_url( array(), array('start') );
	if ( !empty($map_url) )
	{
		$link_title = sprintf( l10n('displays %s on a map'), strip_tags($page['title']) );
		$template->concat( 'PLUGIN_INDEX_ACTIONS' ,'
<li><a href="'.$map_url.'" title="'.$link_title.'" rel="nofollow"><img src="'.get_root_url().'plugins/'.$rvm_dir.'/icons/map_m.png" class="button" alt="map"></a></li>
');
 	}

//  if ( empty($map_url) )
	{
		$kml_url = rvm_duplicate_kml_index_url( array(), array('start') );
		$link_title = sprintf( l10n('opens %s in Google Earth'), strip_tags($page['title']) );
		$template->concat( 'PLUGIN_INDEX_ACTIONS' ,'
<li><a href="'.$kml_url.'" title="'.$link_title.'" rel="nofollow" type="application/vnd.google-earth.kml+xml"><img src="'.get_root_url().'plugins/'.$rvm_dir.'/icons/earth_m.png" class="button" alt="earth"></a></li>
');
	}
}

function rvm_picture_pictures_data($pictures)
{
	if ( isset($pictures['current']['lat']) and isset($pictures['current']['lon']) )
	{
		global $template;
		$template->append('head_elements', '<meta name="geo.position" content="'.$pictures['current']['lat'].';'.$pictures['current']['lon'].'">' );
		include_once( dirname(__FILE__) .'/include/functions.php');
		rvm_load_language();
		if ( isset($_GET['map']) )
			include_once( dirname(__FILE__) .'/include/picture_map.inc.php');
		else
		{
			global $rvm_dir;
			$map_url = rvm_duplicate_map_picture_url();
			if (!empty($map_url))
			{
				$link_title = sprintf( l10n('displays %s on a map'), strip_tags($pictures['current']['name']) );
				$template->concat('PLUGIN_PICTURE_ACTIONS', '
<a href="'.$map_url.'" title="'.$link_title.'" rel="nofollow" target="_top"><img src="'.get_root_url().'plugins/'.$rvm_dir.'/icons/map_m.png" class="button" alt="map"></a>
');
			}
		}
	}
	else
		if ( isset($_GET['map']) )
			redirect( duplicate_picture_url() );
	return $pictures;
}

function rvm_plugin_admin_menu($menu)
{
	include_once( dirname(__FILE__) .'/include/functions.php');
	add_event_handler('invalidate_user_cache', 'rvm_invalidate_cache' );

	array_push($menu,
			array(
				'NAME' => 'Maps & Earth',
				'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/admin.php')
			)
		);
	return $menu;
}

?>